"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var FileUploader_exports = {};
__export(FileUploader_exports, {
  default: () => FileUploader_default
});
module.exports = __toCommonJS(FileUploader_exports);
var import_jsx_runtime = require("react/jsx-runtime");
var import_style = require("./style");
var import_utils = require("./utils");
var import_react = require("react");
var import_DrawTypes = __toESM(require("./DrawTypes"));
var import_ImageAdd = __toESM(require("./ImageAdd"));
var import_useDragging = __toESM(require("./useDragging"));
const drawDescription = (currFile, uploaded, typeError, disabled, label) => {
  return typeError ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
    children: "File type/size error, Hovered on types!"
  }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_style.Description, {
    children: disabled ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
      children: "Upload disabled"
    }) : !currFile && !uploaded ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {
      children: label ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, {
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
            children: label.split(" ")[0]
          }),
          " ",
          label.substr(label.indexOf(" ") + 1)
        ]
      }) : /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, {
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
            children: "Upload"
          }),
          " or drop a file right here"
        ]
      })
    }) : /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, {
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
          children: "Uploaded Successfully!."
        }),
        " Upload another?"
      ]
    })
  });
};
const FileUploader = (props) => {
  const {
    name,
    hoverTitle,
    types,
    handleChange,
    classes,
    children,
    maxSize,
    minSize,
    fileOrFiles,
    onSizeError,
    onTypeError,
    onSelect,
    onDrop,
    disabled,
    label,
    multiple,
    onDraggingStateChange
  } = props;
  const labelRef = (0, import_react.useRef)(null);
  const inputRef = (0, import_react.useRef)(null);
  const [uploaded, setUploaded] = (0, import_react.useState)(false);
  const [currFiles, setFile] = (0, import_react.useState)(null);
  const [error, setError] = (0, import_react.useState)(false);
  const validateFile = (file) => {
    if (types && !(0, import_utils.checkType)(file, types)) {
      setError(true);
      if (onTypeError)
        onTypeError("File type is not supported");
      return false;
    }
    if (maxSize && (0, import_utils.getFileSizeMB)(file.size) > maxSize) {
      setError(true);
      if (onSizeError)
        onSizeError("File size is too big");
      return false;
    }
    if (minSize && (0, import_utils.getFileSizeMB)(file.size) < minSize) {
      setError(true);
      if (onSizeError)
        onSizeError("File size is too small");
      return false;
    }
    return true;
  };
  const handleChanges = (files) => {
    let checkError = false;
    if (files) {
      if (files instanceof File) {
        checkError = !validateFile(files);
      } else {
        for (let i = 0; i < files.length; i++) {
          const file = files[i];
          checkError = !validateFile(file) || checkError;
        }
      }
      if (checkError)
        return false;
      if (handleChange)
        handleChange(files);
      setFile(files);
      setUploaded(true);
      setError(false);
      return true;
    }
    return false;
  };
  const blockEvent = (ev) => {
    ev.preventDefault();
    ev.stopPropagation();
  };
  const handleClick = (ev) => {
    ev.stopPropagation();
    if (inputRef && inputRef.current) {
      inputRef.current.click();
    }
  };
  const handleInputChange = (ev) => {
    const allFiles = ev.target.files;
    const files = multiple ? allFiles : allFiles[0];
    const success = handleChanges(files);
    if (onSelect && success)
      onSelect(files);
  };
  const dragging = (0, import_useDragging.default)({
    labelRef,
    inputRef,
    multiple,
    handleChanges,
    onDrop
  });
  (0, import_react.useEffect)(() => {
    onDraggingStateChange == null ? void 0 : onDraggingStateChange(dragging);
  }, [dragging]);
  (0, import_react.useEffect)(() => {
    if (fileOrFiles) {
      setUploaded(true);
      setFile(fileOrFiles);
    } else {
      if (inputRef.current)
        inputRef.current.value = "";
      setUploaded(false);
      setFile(null);
    }
  }, [fileOrFiles]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_style.UploaderWrapper, {
    overRide: children,
    className: `${classes || ""} ${disabled ? "is-disabled" : ""}`,
    ref: labelRef,
    htmlFor: name,
    onClick: blockEvent,
    children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("input", {
        onClick: handleClick,
        onChange: handleInputChange,
        accept: (0, import_utils.acceptedExt)(types),
        ref: inputRef,
        type: "file",
        name,
        disabled,
        multiple
      }),
      dragging && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_style.HoverMsg, {
        children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", {
          children: hoverTitle || "Drop Here"
        })
      }),
      !children && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, {
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ImageAdd.default, {}),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_style.DescriptionWrapper, {
            error,
            children: [
              drawDescription(currFiles, uploaded, error, disabled, label),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_DrawTypes.default, {
                types,
                minSize,
                maxSize
              })
            ]
          })
        ]
      }),
      children
    ]
  });
};
var FileUploader_default = FileUploader;
//# sourceMappingURL=FileUploader.js.map
